package asset

import (
	"embed"
	"image"

	"github.com/hajimehoshi/ebiten/v2"

	_ "image/png"
)

//go:embed image
var FS embed.FS

const tileSize = 64

var ImgPlayer = LoadImage("image/player.png")

func LoadImage(p string) *ebiten.Image {
	f, err := FS.Open(p)
	if err != nil {
		panic(err)
	}
	defer f.Close()

	baseImg, _, err := image.Decode(f)
	if err != nil {
		panic(err)
	}

	return ebiten.NewImageFromImage(baseImg)
}

func LoadBytes(p string) []byte {
	b, err := FS.ReadFile(p)
	if err != nil {
		panic(err)
	}
	return b
}

func FrameAt(img *ebiten.Image, x int, y int) *ebiten.Image {
	xPos, yPos := x*tileSize, y*tileSize
	return img.SubImage(image.Rect(xPos, yPos, xPos+tileSize, yPos+tileSize)).(*ebiten.Image)
}
